#include <cds/init.h>
#include <cds/gc/dhp.h>
#include <cds/intrusive/treiber_stack.h>
#include <iostream>
#include <string>

using namespace std;

namespace ci = cds::intrusive;
typedef cds::gc::HP gc;

struct Foo : public ci::treiber_stack::node<gc> {
  Foo(int x) : x(x) {}
  int x;
};

struct MyTraits : public cds::intrusive::treiber_stack::traits {
  typedef cds::intrusive::treiber_stack::stat<> stat;
};

// Equivalent make_traits example:
typedef cds::intrusive::TreiberStack<cds::gc::HP, Foo> MyStack;

int main() {
  cds::Initialize();

	{
		// Initialize Hazard Pointer singleton
  	cds::gc::HP hpGC(128, 8, 128);
		// If main thread uses lock-free containers
		// the main thread should be attached to libcds infrastructure
		cds::threading::Manager::attachThread();

    MyStack s(1024);
    Foo* f = new Foo(1);
    Foo* res = nullptr;
    s.push(*f);
    res = s.pop();
    if (res) {
      cout << "Pop " << res->x << "\n";
    } else {
      cout << "Pop none\n";
    }
  }

  cds::Terminate();
  return 0;
}
