#include "common.h"
#include <atomic>
#include <cds/gc/dhp.h>
#include <cds/gc/hp.h>
#include <cds/misc/mcs-lock.h>
#include <cds_test/stress_test.h>
#include <iostream>
#include <memory>
#include <thread>

using namespace std;

namespace {

static size_t s_nMCSLockThreadCount = 6;
static size_t s_nMCSLockPassCount = 3000000;

class MCSLockTest : public cds_test::stress_fixture {
protected:
  static ullong x;

  static void SetUpTestCase() {
    cds_test::config const &cfg = get_config("SequentialMisc");
    GetConfig(MCSLockPassCount);
    GetConfig(MCSLockThreadCount);
  }
};

ullong MCSLockTest::x;

TEST_F(MCSLockTest, MCSLock) {
  cds_others::BackoffTraits::lower_bound = 16;
  cds_others::BackoffTraits::upper_bound = 1024;
  std::unique_ptr<cds_others::mcs_mutex> my_mutex(new cds_others::mcs_mutex());
  cds_others::mcs_mutex::guard g(my_mutex.get());
  my_mutex->unlock(&g);
  for (size_t i = 0; i < s_nMCSLockPassCount; i++) {
    my_mutex->lock(&g);
    x++;
    my_mutex->unlock(&g);
  }
  my_mutex->lock(&g);
}

} // namespace
