#include "common.h"
#include <atomic>
#include <cds/gc/dhp.h>
#include <cds/gc/hp.h>
#include <cds/misc/barrier.h>
#include <cds_test/stress_test.h>
#include <iostream>
#include <memory>
#include <vector>

using namespace std;

namespace {

typedef cds_others::SpinBarrier Barrier;

static size_t s_nBarrierThreadCount = 2;
static size_t s_nBarrierPassCount = 1;

class BarrierTest : public cds_test::stress_fixture {
protected:
  static size_t count;

  static void SetUpTestCase() {
    cds_test::config const &cfg = get_config("SequentialMisc");
    GetConfig(BarrierPassCount);
    GetConfig(BarrierThreadCount);
  }
};

size_t BarrierTest::count;

TEST_F(BarrierTest, Wait) {
  std::unique_ptr<Barrier> barrier(new Barrier(1));
  for (size_t i = 0; i < s_nBarrierPassCount; i++) {
    if (barrier->wait()) {
      count++;
    }
  }
  EXPECT_EQ(count, s_nBarrierPassCount);
}

} // namespace
